import { __decorate } from "tslib";
import { observable } from '@microsoft/fast-element';
import { FoundationElement } from '@microsoft/fast-foundation';
import { foundationBannerStyles as styles } from './banner.styles';
import { foundationBannerTemplate as template } from './banner.template';
export const foundationBannerShadowOptions = {
    mode: 'open',
    delegatesFocus: true,
};
/**
 * @tagname %%prefix%%-banner
 */
export class Banner extends FoundationElement {
    constructor() {
        super(...arguments);
        this.dismissAnimation = '';
    }
    connectedCallback() {
        super.connectedCallback();
    }
    /**
     * Dismiss the Banner from display.
     */
    dismiss() {
        this.dismissAnimation = 'banner-delete';
        return new Promise((resolve) => {
            this.banner.onanimationend = () => {
                this.remove();
                resolve();
            };
        });
    }
}
__decorate([
    observable
], Banner.prototype, "dismissAnimation", void 0);
/**
 * The Foundation Banner
 *
 * @public
 * @remarks
 * HTML Element: \<foundation-banner\>
 */
export const foundationBanner = Banner.compose({
    baseName: 'banner',
    styles,
    template,
    shadowOptions: foundationBannerShadowOptions,
});
